<!DOCTYPE HTML PUBLIC "-//W3O//DTD W3 HTML 2.0//EN">
<!-- This collection of hypertext pages is Copyright 1995-7 by Steve Summit. -->
<!-- This material may be freely redistributed and used -->
<!-- but may not be republished or sold without permission. -->
<html>
<head>
<link rev="owner" href="mailto:scs@eskimo.com">
<link rev="made" href="mailto:scs@eskimo.com">
<title>Assignment #6</title>
</head>
<body>
<H1>Assignment #6</H1>





<B>Introductory C Programming
<br>
<br>
UW Experimental College
</B><br>
<br>
<B>Assignment #6
</B><p><B>Handouts:
</B></p><p><a href="PS6.html">Assignment #6</a>
<br><a href="PS5a.html">Assignment #5 Answers</a>
<br><a href="http://www.eskimo.com/~scs/cclass/notes/sx11.html">Class Notes, Chapter 11</a>
<br><a href="http://www.eskimo.com/~scs/cclass/notes/sx12.html">Class Notes, Chapters 12</a>
<a href="http://www.eskimo.com/~scs/cclass/notes/sx13.html">and 13</a>
<p><B>Reading Assignment:
</B></p><p><a href="http://www.eskimo.com/~scs/cclass/notes/sx10.html">Class Notes, Chapters 10</a>
<a href="http://www.eskimo.com/~scs/cclass/notes/sx11.html">and 11</a>
<p><B>Review Questions:
</B></p><OL><li>If we say
<pre>
	int i = 5;
	int *ip = &amp;i;
</pre>
then what is <TT>ip</TT>?
What is its value?
<li>If <TT>ip</TT> is a pointer to an integer, what does <TT>ip++</TT> mean?
What does
<pre>
	*ip++ = 0;
</pre>
do?
<li>How much memory does the call <TT>malloc(10)</TT> allocate?  What if
you want enough memory for 10 <TT>int</TT>s?
<li>The assignment in
<pre>
	char c;
	int *ip = &amp;c;		/* WRONG */
</pre>
is in error; you can't mix <TT>char</TT> pointers and <TT>int</TT> pointers like
this.  How, then, is is possible to write
<pre>
	char *cp = malloc(10);
	int *ip = malloc(sizeof(int));
</pre>
without error on either line?
</OL><br>
<br>
<p><B>Exercises:
</B></p><OL><li>Write a program to read lines and print only those containing
a certain word.
(For now, the word can be a constant string in the program.)
The basic pattern
(which I have to confess I have parroted exactly from K&amp;R Sec. 4.1)
is
<pre>
	while(<I>there's another line</I>)
		{
		if(<I>line contains word</I>)
			<I>print the line</I>;
		}
</pre>
Use the <TT>strstr</TT> function (mentioned in the notes) to look for the
word.  Be sure to include the line
<pre>
	#include &lt;string.h&gt;
</pre>
at the top of the source file where you call <TT>strstr</TT>.
<li>Rewrite the checkbook-balancing program from
assignment 4 (exercise 6)
to use the
<TT>getwords</TT> function (from the notes) to make it easy to take the
word ``check'' or ``deposit'', <I>and</I> the amount, from a single line.
<li>Rewrite the line-reversing function from
assignment 4 (exercise 9)
to use pointers.
<li>Rewrite the character-counting function from
assignment 5 (exercise 3)
to use pointers.
<li>Rewrite the string-concatenation program from assignment 5 (exercise 4)
to call <TT>malloc</TT> to allocate a new piece of memory just big enough
for the concatenated result.  Don't forget to leave room for the
<TT>\0!</TT>
<li>Rewrite the string-replacing function from
assignment 5 (exercise 5)
to use pointers.
<li>(harder)
Write a program to read lines of text up to <TT>EOF</TT>, and
then print them out in reverse order.  You can use <TT>getline</TT> to
read each line into a fixed-size array (as we have been doing
all along), but you will have to call <TT>malloc</TT> and make a copy of
each line before you read the next one.  Also, you will have to
use <TT>malloc</TT> and <TT>realloc</TT> to maintain the ``array'' of character pointers
which holds all of the lines.  (Your code will be similar to that
in section 11.3 of the notes, p. 5)
<br>
<br>
Extra credit: remove the restriction imposed by the fixed-size
array into which each line is originally read; allow the program
to accept arbitrarily many arbitrarily-long lines.  (You'll have
to replace <TT>getline</TT> with a dynamically-allocating line-getting
function which calls <TT>malloc</TT> and <TT>realloc</TT>.)
</OL><hr>
<hr>
<p>
This page by <a href="http://www.eskimo.com/~scs/">Steve Summit</a>
// <a href="copyright.html">Copyright</a> 1995-9
// <a href="mailto:scs@eskimo.com">mail feedback</a>
</p>
</body>
</html>
